﻿namespace HeuristicLab.Problems.ProgramSynthesis {
  using HeuristicLab.Common;
  using HeuristicLab.Core;
  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

  [StorableClass]
  public abstract class ErcOption<T> : ErcOptionConvertible<T, T> {
    protected ErcOption() : this(false, new WeightedErcItem<T>[0]) { }

    protected ErcOption(bool isEnabled, params WeightedErcItem<T>[] values)
        : base(isEnabled, values) { }

    [StorableConstructor]
    protected ErcOption(bool deserializing)
        : base(deserializing) {
    }

    protected ErcOption(ErcOptionConvertible<T, T> origin, Cloner cloner)
        : base(origin, cloner) {
    }

    public override T GetErcValue(IRandom random) {
      return GetErcValue(random, x => x);
    }
  }
}
